#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>

#include "aspi.h"
#include "scsidefs.h"
#include "cdrom.h"
     
static unsigned char cdb[12];
static int target;

main(int argc, char **argv)
{
  int i, max, n, t, s;
  int h, oh;
  unsigned char buf[16384];
  int TRANSFERS=8;
  int da_first=0, da_last=0;
  char *fn;
  FILE *f;

  if (argc != 2)
  {
    fprintf(stderr, "Usage: getcd [file]\n");
    exit(1);
  }

  fn = argv[1];

  target = cd_open();

  do {
    memset(cdb, 0, 6);
    s = aspi_exec(target, 0, 0, ASPI_RW_NODATA, cdb, 6);
  } while (s != 1 && (aspi_sense[12] == 0x28 || aspi_sense[12] == 0x04));
  check_sense(0, s, "test unit ready");

  memset(cdb, 0, 6);
  cdb[0] = 0x15;
  cdb[1] = 0x10;
  cdb[4] = 4 + 8 + 4;
  memset(buf, 0, 16);
  buf[3] = 8; /* specify a block descriptor */
  buf[4+6] = 0x08;
  buf[4+7] = 0x00;
  buf[4+8+0] = 0x31;
  buf[4+8+1] = 2;
  buf[4+8+2] = 0;
  buf[4+8+3] = 0x20; /* quad speed */
  s = aspi_exec(target, buf, 4+8+4, ASPI_RW_WRITE, cdb, 6);
  check_sense(0, s, "mode select");

  memset(cdb, 0, 10);
  cdb[0] = 0xe5;
  cdb[5] = 1;
  cdb[8] = 19;
  s = aspi_exec(target, buf, 19, ASPI_RW_READ, cdb, 10);
  check_sense(0, s, "read track info");

  da_first = swapl(*(unsigned long *)(buf+2));
  da_last = da_first + swapl(*(unsigned long *)(buf+6)) - 1;

  f = fopen(fn, "wb");
  if (f == 0)
  {
    fprintf(stderr, "Cannot open file %s for writing\n", fn);
    perror("The error was");
    exit(1);
  }

  h = (da_last-da_first+1)*2;
  printf("\nReading track 1  ");
  if (h < 999)
    printf("%d Kb\n", h);
  else
    printf("%d,%03d Kb\n", h/1000, h%1000);

  h = 0;
  oh = 0;
  for (i=da_first; i<=da_last; i+=t)
  {
    t = TRANSFERS;
    if (t > da_last-i+1)
      t = da_last-i+1;
    memset(cdb, 0, 10);
    cdb[0] = 0x28;
    *(unsigned long *)(cdb+2) = swapl(i);
    cdb[8] = t;

    s = aspi_exec(target, buf, 2048*t, ASPI_RW_READ, cdb, 10);
    if (s != 1)
    {
      if (TRANSFERS > 1)
      {
	t = 0;
	TRANSFERS >>= 1;
	continue;
      }
      if (i > da_last-2)
	i += 2;
      else
      {
	check_sense(0, s, "read");
      }
    }

    h += t;
    fwrite(buf, 1, 2048*t, f);

    oh += t;
    if (oh >= 128 || TRANSFERS < 8)
    {
      int q = h*2;
      if (q > 999)
	printf("\r%3d,%03d kb ", q/1000, q%1000);
      else
	printf("\r%7d kb ", q);
      fflush(stdout);
      oh -= 128;
      if (kbhit())
      {
	getkey();
	break;
      }
    }
  }
  fclose(f);

  cd_close(0);

  return 0;
}
