#include <stdio.h>
#include <string.h>
#include <io.h>

#include "wave.h"

int
setup_wave(int fd)
{
  char buf[4];
  unsigned long l;
  unsigned short s;
  read(fd, buf, 4);
  if (memcmp(buf, "RIFF", 4))
    return 0;
  read(fd, &l, 4);
  read(fd, buf, 4);
  if (memcmp(buf, "WAVE", 0))
    return 0;
  while (1)
  {
    if (read(fd, buf, 4) < 4)
      return 0;
    if (memcmp(buf, "fmt ", 4) == 0)
    {
      read(fd, &l, 4); if (l != 16) return 0;
      read(fd, &s, 2); if (s != 1) return 0;
      read(fd, &s, 2); if (s != 2) return 0;
      read(fd, &l, 4); if (l != 44100) return 0;
      read(fd, &l, 4); if (l != 44100*4) return 0;
      read(fd, &s, 2); if (s != 4) return 0;
      read(fd, &s, 2); if (s != 16) return 0;
    }
    else if (memcmp(buf, "data", 4) == 0)
    {
      read(fd, &l, 4);
      return l;
    }
    else
    {
      read(fd, &l, 4);
      lseek(fd, l, SEEK_CUR);
    }
  }
}

void
write_wave(int fd, int size)
{
  unsigned long l;
  unsigned short s;
  write(fd, "RIFF", 4);
  l = size+36; write(fd, &l, 4);
  write(fd, "WAVE", 4);
  write(fd, "fmt ", 4);
  l = 16; write(fd, &l, 4);
  s = 1; write(fd, &s, 2);
  s = 2; write(fd, &s, 2);
  l = 44100; write(fd, &l, 4);
  l = 44100*4; write(fd, &l, 4);
  s = 4; write(fd, &s, 2);
  s = 16; write(fd, &s, 2);
  write(fd, "data", 4);
  l = size; write(fd, &l, 4);
}
